'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isPromise = require('./utils/isPromise');

var _isPromise2 = _interopRequireDefault(_isPromise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var promises = [];

  var promisesMiddleware = function promisesMiddleware(_ref) {
    var dispatch = _ref.dispatch;
    var getState = _ref.getState;

    return function (next) {
      return function (action) {
        if (typeof action === 'function') {
          var promise = action(dispatch, getState);
          if ((0, _isPromise2.default)(promise)) {
            promises.push(promise);
          }
        } else {
          next(action);
        }
      };
    };
  };

  promisesMiddleware.then = function (onFulfilled, onRejected) {
    return Promise.all(promises).then(onFulfilled, onRejected);
  };

  return promisesMiddleware;
};

module.exports = exports['default'];